REM=======================================================
REM Step1. Start Record
REM=======================================================
echo [ASUS Driver Install Start] >>C:\Windows\Logs\ASUSDriverInstall.log
echo %date% %time% >>C:\Windows\Logs\ASUSDriverInstall.log

REM=======================================================
REM Check Intel Driver Package Version and Update
REM=======================================================
echo.>>C:\Windows\Logs\ASUSDriverInstall.log
reg query HKLM\SOFTWARE\Intel\SOCPackageInfo /v VersionNumber | findstr "0x31"
if %errorlevel%==0 goto SkipIntel

echo Insatll Inter Driver Start ...>>C:\Windows\Logs\ASUSDriverInstall.log
cd .\CLV_Master_Installer_V1.0
setup -s -report C:\Windows\Logs
set errorcode=%errorlevel%
cd ..
echo Insatll Inter Drive Done with %errorcode% >>C:\Windows\Logs\ASUSDriverInstall.log
if %errorcode% neq 3010 goto ErrorInstall
goto IntelDone

:SkipIntel
echo Intel Driver does not need update!!>>C:\Windows\Logs\ASUSDriverInstall.log

:IntelDone

REM=======================================================
REM Check Sensor Hub Version and Update
REM=======================================================
echo.>>C:\Windows\Logs\ASUSDriverInstall.log
cd .\Firmware\STMicroSensorHubTool_V1.0.0.10
STMicroSensorHubTool.exe /getinfo | findstr /c:"Current Version" | findstr "20"
if %errorlevel% neq 0 goto UpdateSensor

echo Sensor Hub Firmware does not need update!!>>C:\Windows\Logs\ASUSDriverInstall.log

goto SensorDone

:UpdateSensor

STMicroSensorHubTool.exe /update STM32F103_HIDoverI2C_ST_Reference_V0020.hex
set errorcode=%errorlevel%
echo Sensor Hub Firmware Update with %errorcode% >>C:\Windows\Logs\ASUSDriverInstall.log
if %errorcode% neq 0 goto ErrorInstall

:SensorDone
cd ..\..


REM=======================================================
REM Check Digitizer BootLoader Version and Update
REM=======================================================
echo.>>C:\Windows\Logs\ASUSDriverInstall.log
cd .\Firmware\Digitizer

del W92BLFW8.log /f
W92BLFW8-v02.exe -s -v -dump
findstr /c:"0x0025" W92BLFW8.log
if %errorlevel% neq 0 goto UpdateDigitizerBootLoader

echo Digitizer BootLoader does not need update!!>>C:\Windows\Logs\ASUSDriverInstall.log

goto DigitizerBootLoaderDone

:UpdateDigitizerBootLoader

W92BLFW8-v02.exe -s -F2
set errorcode=%errorlevel%
echo Digitizer BootLoader Update with %errorcode% >>C:\Windows\Logs\ASUSDriverInstall.log
if %errorcode% neq 0 goto ErrorInstall

:DigitizerBootLoaderDone
cd ..\..


REM=======================================================
REM Check Digitizer Firmware Version and Update
REM=======================================================
echo.>>C:\Windows\Logs\ASUSDriverInstall.log
cd .\Firmware\Digitizer

del WFlashUSB.log /f
WFlashI2C-v04.exe -s -v -dump
findstr /c:"0x2172" WFlashUSB.log
if %errorlevel% neq 0 goto UpdateDigitizerFirmware

echo Digitizer Firmware does not need update!!>>C:\Windows\Logs\ASUSDriverInstall.log

goto DigitizerFirmwareDone

:UpdateDigitizerFirmware

WFlashI2C-v04.exe -s -F2 W9002_2172.hex
set errorcode=%errorlevel%
echo Digitizer Firmware Update with %errorcode% >>C:\Windows\Logs\ASUSDriverInstall.log
if %errorcode% neq 0 goto ErrorInstall

:DigitizerFirmwareDone
cd ..\..

REM=======================================================
REM Register Current Pacakge Version
REM=======================================================
echo.>>C:\Windows\Logs\ASUSDriverInstall.log
echo Write TF810C Driver Package Version: >>C:\Windows\Logs\ASUSDriverInstall.log
reg import Driver.reg
reg query HKLM\Software\ASUS\Driver >>C:\Windows\Logs\ASUSDriverInstall.log
goto InstallDone

REM=======================================================
REM Register Current Pacakge Version
REM=======================================================
:ErrorInstall
echo.>>C:\Windows\Logs\ASUSDriverInstall.log
echo Error happened during Driver Packing Installing!!>>C:\Windows\Logs\ASUSDriverInstall.log

REM=======================================================
REM End Record
REM=======================================================
:InstallDone
echo %date% %time% >>C:\Windows\Logs\ASUSDriverInstall.log
echo [ASUS Driver Install End] >>C:\Windows\Logs\ASUSDriverInstall.log